<?php

namespace Insallah;

class Achievements
{
    private $user;
    private $info;
    private $data = [
        'zb' => [
            'questname' => '.',
            'quest' => '  .',
            'check' => ['', 5, 25, 50, 100, 250],
            'prize' => [' <br> <br>', 5, 20, 40, 60, 100],
            'startlink' => 11
        ],
        'vx' => [
            'questname' => ' ',
            'quest' => '   .',
            'check' => ['', 50, 300, 400, 500, 1000],
            'prize' => ['.', 25, 50, 75, 100, 200],
            'startlink' => 21
        ],
        'snt' => [
            'questname' => ' ',
            'quest' => '  .',
            'check' => ['', 5, 25, 50, 100, 250],
            'prize' => ['.', 10, 25, 50, 75, 200],
            'startlink' => 31
        ],
        'rp' => [
            'questname' => ' 8 .',
            'quest' => '     . [S]',
            'check' => ['', 5, 10, 25, 50, 100],
            'prize' => [' <br>  <br>', 5, 7, 10, 12, 15],
            'startlink' => 41
        ],
        'rn' => [
            'questname' => ' 9 .',
            'quest' => '     . [M]',
            'check' => ['', 5, 10, 15, 25, 50],
            'prize' => [' <br>  <br>', 5, 7, 9, 12, 15],
            'startlink' => 51
        ],
        'rb' => [
            'questname' => ' 10 .',
            'quest' => '     . [L]',
            'check' => ['', 2, 5, 8, 11, 15],
            'prize' => [' <br>  <br>', 2, 4, 6, 10, 15],
            'startlink' => 61
        ],
        'pg' => [
            'questname' => '. ',
            'quest' => '   .',
            'check' => ['', 100, 200, 400, 600, 1000],
            'prize' => [' <br> <br>', 10, 20, 40, 60, 80],
            'startlink' => 71
        ],
        'bv' => [
            'questname' => ' ',
            'quest' => '     .',
            'check' => ['', 5, 25, 50, 100, 250],
            'prize' => ['.', 500, 1000, 2000, 4000, 5000],
            'startlink' => 81
        ],
        'kw' => [
            'questname' => ' ',
            'quest' => '   .',
            'check' => ['', 5, 10, 15, 20, 25],
            'prize' => [' <br> <br>  ', 1, 2, 5, 10, 15],
            'startlink' => 91
        ],
        'pa' => [ # not implemented!
            'questname' => '',
            'quest' => '  .',
            'check' => ['', 5, 25, 50, 100, 250],
            'prize' => null,
            'startlink' => null
        ],
        'bs' => [
            'questname' => ' ',
            'quest' => '   .',
            'check' => ['', 1, 5, 10, 50, 500],
            'prize' => ['.', 1, 5, 10, 50, 200],
            'startlink' => 101
        ],
        'trn' => [ # not implemented!
            'questname' => '',
            'quest' => '  .',
            'check' => ['', 25, 50, 100, 200, 500],
            'prize' => ['.', 25, 25, 25, 25, 50],
            'startlink' => 111
        ],
    ];

    public function __construct(\User $user)
    {
        $this->user = $user;
        $this->info = Db::getRow('select * from users_achiv where id = ?', [$user->info['id']]);
    }

    private function prizeName($int, $string)
    {
        return in_array($string, ['.', '.']) ? $int . ' ' . $string : $string . ' ' . $int;
    }

    private function drawSunduk($nagr, $whatInside, $tier)
    {
        return vsprintf('<img onclick="%s" onmouseover="%s" onmouseout="%s" onmousedown="%s" class="cp" src="%s" alt="">',
            [
                "location.href='\main.php?titul&nagr=$nagr'",
                "top.hi(this, '<b> $tier <hr>:<hr> $whatInside</b>', event, 2, 0, 1, 1, 'max-width:307px')",
                "top.hic();",
                "top.hic();",
                "https://img.new-combats.com/i/titul/nagr$tier.gif"
            ]);
    }

    public function getList()
    {
        $string = '';
        $this->calculateCurrent(1);

        foreach ($this->data as $key => $value) {
            //,    !
            //  =        ( )
            //  =       ()
            //           0.
            //  ,     ,      .
            //   -  . FFUUUUUUUUUUUUUU!!! Ins.
            $percentToSuccess = Math::get100Percentage(
                $value['check'][$this->info['klas' . $key] + 1] - $value['check'][$this->info['klas' . $key]],
                $this->info[$key] - $value['check'][$this->info['klas' . $key]]
            );
            $questname = empty($value['questname']) ? $value['quest'] : $value['questname'];
            $string .= '<h4>' . $questname . '</h4>';
            $string .= '<strong>' . $value['quest'] . '</strong><br>';
            $string .= ' : <strong>' . $this->info['klas' . $key] . '</strong> ';
            $string .= ' ' . mb_strtolower($value['check'][0]) . ': <strong>' . $this->info[$key] . ' =' . $percentToSuccess . '%</strong>';

            $string .= Table::get([
                ['', 1, 2, 3, 4, 5],
                $value['check'],
                [
                    '',
                    $this->prizeName($value['prize'][1], $value['prize'][0]),
                    $this->prizeName($value['prize'][2], $value['prize'][0]),
                    $this->prizeName($value['prize'][3], $value['prize'][0]),
                    $this->prizeName($value['prize'][4], $value['prize'][0]),
                    $this->prizeName($value['prize'][5], $value['prize'][0])
                ]
            ], 'prizelist', true);
            # If has new tier, AND only first 5 tiers AND prize is set.
            if (
                $this->info['klas' . $key] > $this->info[$key . '_n'] &&
                in_array($this->info[$key . '_n'], [0, 1, 2, 3, 4]) &&
                !empty($value['prize']) &&
                !empty($value['startlink'])
            ) {
                $string .= '<br>:<br>';
                $string .= $this->drawSunduk(
                    $this->info[$key . '_n'] + $value['startlink'],
                    $this->prizeName($value['prize'][$this->info[$key . '_n'] + 1], $value['prize'][0]),
                    $this->info[$key . '_n'] + 1
                );
            }
            $string .= '<hr>';
        }
        return $string;
    }

    private function calculateCurrent($check = null)
    {
        $this->info['bs'] = $this->user->info['win_bs'];
        foreach ($this->info as $k => $v) {
            if (
                empty($this->info[$k]) &&
                is_null($check) ||
                $k === 'id' ||
                !in_array($k, array_keys($this->data))
            ) {
                continue;
            }

            $this->info["klas$k"] = 0;
            $this->info["name$k"] = $this->data[$k]['questname'];
            $this->info["klasP$k"] = Math::get100Percentage($this->data[$k]['check'][1], $this->info[$k]);

            for ($i = 1; $i <= 5; $i++) {
                if ($this->info[$k] >= $this->data[$k]['check'][$i]) {
                    $this->info["klas$k"] = $i;
                    if ($i === 5) {
                        #  5    .
                        $this->info["klasP$k"] = 100;
                    } else {
                        $this->info["klasP$k"] = Math::get100Percentage(
                            $this->data[$k]['check'][$i + 1] - $this->data[$k]['check'][$i],
                            $this->info[$k] - $this->data[$k]['check'][$i]
                        );
                    }
                }
            }
        }
    }

    public function getInfo($user_id = null)
    {
        if (!is_null($user_id)) {
            $this->info = Db::getRow('select * from users_achiv where id = ?', [$user_id]);
        }
        $this->calculateCurrent();
        return $this->info;
    }

    public function getCheckedInfo()
    {
        $this->calculateCurrent(1);
        return $this->info;
    }

    private function addOne($name)
    {
        Db::sql("update users_achiv set $name = $name + 1 where id = ?", [$this->user->info['id']]);
    }

    public function updateTier($name)
    {
        if (in_array($name, array_keys($this->data))) {
            $this->addOne($name . '_n');
        }
    }

    public function updateCounter($name)
    {
        if (in_array($name, array_keys($this->data))) {
            $this->addOne($name);
        }
    }

    /**
     * @return array[]
     */
    public function getData()
    {
        return $this->data;
    }

    public function hasNoTier4Access($nagr)
    {
        return $this->user->info['level'] < 9 && in_array($nagr, [14, 15, 24, 25, 34, 35, 44, 45, 54, 55, 64, 65, 74, 75, 84, 85, 94, 95, 104, 105]);
    }

    public function givePrizeItems($itemId, $aType)
    {
        for ($i = 1; $i <= $this->data[$aType]['prize'][$this->info[$aType . '_n'] + 1]; $i++) {
            $this->user->addItem($itemId, $this->user->info['id']);
        }
    }

    public function getTypes()
    {
        return array_keys($this->data);
    }
}